---
sort: 0
---

# Preface

When Spring came to the 5.x era, I had followed the official development progress in that period and tasted the new features as early as possible. Then I wrote down a long article - [Reactive Programming with Spring 5](https://hantsy.medium.com/reactive-programming-with-spring-5-3bfc5d324ba0) to introduce the new **Reactive** feature introduced in Spring 5. Aside from this article, I have created a collection of small example projects to demonstrate the usage mentioned in this article. The example codes can be fetched from [hantsy/spring-reactive-sample](https://github.com/hantsy/spring-reactive-sample).

As time goes by, some content in the original article are out of date, and the example codes also should be refreshed according to the changes in the latest Spring and Spring Boot. So I decided to restructure the article into a mini book form and update the example codes simultaneously.

## Audience

It is a book to introduce the newest Spring WebFlux stack.

It is not a comprehensive reference book to explore Spring framework. If you are new to Spring, I suggest you read [Spring in Action](https://www.manning.com/books/spring-in-action-sixth-edition) from Manning or [Pro Spring](https://www.apress.com/gp/book/9781430261520) from Apress firstly.

I assume that you have some experience in Spring application development and know well about Java 8/11 language syntax.

## Example Codes

When introducing new things to the newbie, I believe that *one example exceeds one thousand words*.  For all *Reactive* features in Spring and its ecosystem, including Spring Data, Spring Security, Spring Session, etc.,  I would like to explore them with simple working examples.

All example codes used in this book are available in the Github repository: [hantsy/spring-reactive-sample](https://github.com/hantsy/spring-reactive-sample). In the README file, I listed all examples clearly with a simple description, you can select any of them and practice yourself.

## Contribution

Any form of contribution is welcome.

Please [file an issue](https://github.com/hantsy/spring-reactive-sample/issues) if there is an error found in the sample codes or some content of the book itself, or send a request for that is missing in the book.

If my work is helpful, please help me to spread it out to your circles or [buy me a coffee](https://www.buymeacoffee.com/hantsy).:)

## About Me

I am an impendent freelancer from China with about 20 years of software engineering experience. If you need some development and technical consulting service, please drop me an email, my email address is hantsy@gmail.com.

Enjoy reading!
